<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, height=device-height, initial-scale=1.0">
    <title>Document</title>
    <style media="screen">
        body, div{
      margin: 0px;
      padding: 0px;
      border: 0px;
      white-space-collapse: none;

      box-sizing: border-box;

    }
    input, button {

      box-sizing: border-box;

    }
    .scroll {
        overflow-y: scroll;
        padding: 1%;
    }
  </style>
</head>

<body style="margin: 0px; padding: 0px;">

    <div style="width: 100vw; height: 100vh; display: flex;" id="body">


        <div id="boxes" style="display: inline-block; height: 100%; width: 70%;">
            <div id="container-1" style="display: flex; height: 33%; width: 100%;">
                <div class="" id="input-1" style="height: 100%; width: 50%; display: inline-block;  border: 1px solid black;">

                    <div style="height: 15%; width: 100%;">
                        <input type="text" id="input-1-text" style="margin: 0px 40% 0px 40%; width: 20%; display: inline-block; height: 100%;" onkeyup="makeInput(1);"></input>
                    </div>
                    <div id="input-1-content" style="height: 85%; width: 100%;">

                    </div>







                </div>
                <div class="scroll" id="word-1" style="height: 100%; width: 25%; display: inline-block; border: 1px solid black;">

                </div>
                <div class="scroll" id="letter-1" style="height: 100%; width: 25%; display: inline-block; border: 1px solid black;">

                </div>

            </div>
            <div id="container-2" style="display: flex; height: 33%; width: 100%;">
                <div class="" id="input-2" style="height: 100%; width: 50%; display: inline-block; border: 1px solid black;">

                    <div style="height: 15%; width: 100%;">
                        <input type="text" id="input-2-text" style="margin: 0px 40% 0px 40%; width: 20%; display: inline-block; height: 100%;" onkeyup="makeInput(2);"></input>
                    </div>
                    <div id="input-2-content" style="height: 85%; width: 100%;">

                    </div>


                </div>
                <div class="scroll" id="word-2" style="height: 100%; width: 25%; display: inline-block; border: 1px solid black;">

                </div>
                <div class="scroll" id="letter-2" style="height: 100%; width: 25%; display: inline-block; border: 1px solid black;">

                </div>

            </div>
            <div id="container-3" style="display: flex; height: 34%; width: 100%;">
                <div class="" id="input-3" style="height: 100%; width: 50%; display: inline-block; border: 1px solid black;">

                    <div style="height: 15%; width: 100%;">
                        <input type="text" id="input-3-text" style="margin: 0px 40% 0px 40%; width: 20%; display: inline-block; height: 100%;" onkeyup="makeInput(3);"></input>
                    </div>
                    <div id="input-3-content" style="height: 85%; width: 100%;">

                    </div>


                </div>
                <div class="scroll" id="word-3" style="height: 100%; width: 25%; display: inline-block; border: 1px solid black;">

                </div>
                <div class="scroll" id="letter-3" style="height: 100%; width: 25%; display: inline-block; border: 1px solid black;">

                </div>

            </div>
        </div>

        <div id="right-content" style="display: inline-block; height: 100%; width: 30%">

            <div class="" id="input" style="height: 33%; width: 100%; display: block; border: 1px solid black;">
                <!-- <button type="text" style="margin: 0% 20% 20% 20%; height: 10%; width: 60%" onclick="checkAll();">Checar</button> -->
                <input type="text" style="margin: 15% 20% 40% 20%; height: 20%; width: 60%">

            </div>
            <div style="height: 67%; width: 100%; display: flex;">

                <div class="scroll" id="letter" style="height: 100%; width: 80%; display: inline-block; border: 1px solid black;">
                </div>
                <div id="words" style="height: 100%; width: 20%; display: flex; border: 1px solid black; text-align: center; vertical-align: middle;">
                    <p style="margin: auto; text-align: center"></p>
                </div>
            </div>
        </div>




    </div>



    </div>


    <!--<script src="https://code.jquery.com/jquery-3.3.1.min.js"></script>-->
    <script src="jquery.js" charset="utf-8"></script>
    <script src="dicJs.js" charset="utf-8"></script>
    <script src="letters.js" charset="utf-8"></script>
    <script type="text/javascript">
        function makeInput(num) {
            var inputs = "";
            var inpt = $('#input-' + num + '-text');
            var margin = 2;
            for (var x = 0; x < inpt.val(); x++) {
                //if (x % 15 == 0 && x !== 0) inputs += "<br>";
                if (x % 15 == 0) {

                    inputs += '<input type="text" class="letters" style="width: 4%; padding: 0px; margin-left: 5%; margin-top: 2.8%">';

                } else {

                    inputs += '<input type="text" class="letters" style="width: 4%; padding: 0px; margin-left: ' + margin + '%; margin-top: 2.8%">';

                }
            }
            $('#input-' + num + '-content').html(inputs);
            $('input').keyup(function() {
                checkAll();
            });
        }
    </script>

    <script type="text/javascript">
        $(document).ready(function() {
            $('input').val('');
            $('input').keyup(function() {
                checkAll();
            });
        });
    </script>

    <script>
        function checkAll() {
            var oBase = {
                'undef': true
            };
            var o1 = checkWords(1);
            o1 = typeof o1 !== 'undefined' ? o1 : oBase;
            var o2 = checkWords(2);
            o2 = typeof o2 !== 'undefined' ? o2 : oBase;
            var o3 = checkWords(3);
            o3 = typeof o3 !== 'undefined' ? o3 : oBase;
            checkTogether(o1, o2, o3);
        }





        function checkWords(num) {

            var strDont = '[^' + $('#input input').val() + ']';
            var strHas = '';
            var regexDont = new RegExp(strDont, 'g');
            var inputs = $('#input-' + num + '-content input');
            var regex = '';
            var contChar = 0;
            var alreadyHas = "["
            inputs.each(function(idx, el) {
                var str = $(el).val() === '' ? strDont : $(el).val();
                regex += str;
                strHas += $(el).val();
                alreadyHas += $(el).val();
                contChar++;
            });
            alreadyHas += ']';
            regexObj = new RegExp(regex, 'g');
            var strs = "";
            var vetSize = vet[contChar];
            var finalVet = [];
            for (var idx in vetSize) {
                if (vetSize[idx].match(regexObj) !== null) {
                    strs += vetSize[idx] + "<br>";
                    finalVet.push(vetSize[idx]);
                }
            }
            $('#word-' + num).html(strs);

            vetSize = finalVet;




            if (contChar > 0) {
                var contAp = [];
                var contApTotal = [];
                for (var letter in vetLetters) {
                    contAp[letter] = 0;
                    contApTotal[letter] = 0;
                }
                var contWords = 0;

                var regexHas = new RegExp(alreadyHas, 'g');

                for (var key in vetSize) {
                    var word = vetSize[key];
                    contWords++;
                    for (var letter in vetLetters) {
                        var match = word.match(new RegExp(letter, 'g'));
                        if (match !== null) {
                            if (letter.match(regexHas) || !letter.match(new RegExp(strDont, 'g'))) {
                                contAp[letter] = -1;
                                contApTotal[letter] = -1;

                            } else {
                                contAp[letter]++;
                                contApTotal[letter] += match.length;

                            }
                        }
                    }
                }

                var obj = {
                    'apTotal': contApTotal,
                    'ap': contAp,
                    'words': contWords,
                    'strHas': strHas,
                    'undef': false
                };


                var vetTemp = [];

                for (var key in contAp) vetTemp.push([key, contAp[key]]);

                vetTemp.sort((a, b) => b[1] - a[1]);


                str = "";

                for (var x = 0; x < vetTemp.length; x++) {
                    var letter = vetTemp[x][0];
                    if (letter.match(regexHas) || !letter.match(new RegExp(strDont, 'g'))) continue;
                    var val = vetTemp[x][1];
                    var percent = "" + (Math.round(val / contWords * 10000) / 100);
                    percent = percent !== 'NaN' ? percent : 0;
                    vetTemp[x].push(percent);
                    str += letter + " --- " + val + " --- " + percent + "% --- " + contApTotal[letter] + " total<br>"
                }
                $('#letter-' + num).html(str);

                return obj;



            }




        }



        function checkTogether(obj1, obj2, obj3) {

            var strDont = '[^' + $('#input input').val() + ']';
            var regexDont = new RegExp(strDont, 'g');

            var hasChar = false;

            var strHas = '[';
            strHas += obj1.undef ? '' : obj1.strHas;
            strHas += obj2.undef ? '' : obj2.strHas;
            strHas += obj3.undef ? '' : obj3.strHas;
            strHas += ']';
            if (strHas === '[]') {
                strHas = '[.]';
            }
            var regexHas = new RegExp(strHas, 'g');

            var contAp = [];
            var contAp1 = [];
            var contAp2 = [];
            var contAp3 = [];
            var contApTotal = [];
            var contWords = 0;
            contWords += obj1.undef ? 0 : obj1.words;
            contWords += obj2.undef ? 0 : obj2.words;
            contWords += obj3.undef ? 0 : obj3.words;
            contWords1 = obj1.undef ? 0 : obj1.words;
            contWords2 = obj2.undef ? 0 : obj2.words;
            contWords3 = obj3.undef ? 0 : obj3.words;
            for (var key in obj1.ap) {
                contAp[key] = obj1.undef ? 0 : obj1.ap[key];
                contAp[key] += obj2.undef ? 0 : obj2.ap[key];
                contAp[key] += obj3.undef ? 0 : obj3.ap[key];
                contAp1[key] = obj1.undef ? 0 : obj1.ap[key];
                contAp2[key] = obj2.undef ? 0 : obj2.ap[key];
                contAp3[key] = obj3.undef ? 0 : obj3.ap[key];
                contApTotal[key] = obj1.undef ? 0 : obj1.apTotal[key];
                contApTotal[key] += obj2.undef ? 0 : obj2.apTotal[key];
                contApTotal[key] += obj3.undef ? 0 : obj3.apTotal[key];
            }



            var vetTemp = [];

            for (var key in contAp) vetTemp.push([key, contAp[key]]);




            var vetTemp1 = [];

            for (var key in contAp1) vetTemp1.push([key, contAp1[key]]);



            var vetTemp2 = [];

            for (var key in contAp2) vetTemp2.push([key, contAp2[key]]);



            var vetTemp3 = [];

            for (var key in contAp3) vetTemp3.push([key, contAp3[key]]);



            str = '';


            var vetFinal = [];

            for (var x = 0; x < vetTemp.length; x++) {
                var letter = vetTemp[x][0];

                if (letter.match(regexHas) || !letter.match(new RegExp(strDont, 'g'))) continue;

                var o1 = {
                    'num': vetTemp1[x][1],
                    'total': contWords1
                };
                var o2 = {
                    'num': vetTemp2[x][1],
                    'total': contWords2
                };
                var o3 = {
                    'num': vetTemp3[x][1],
                    'total': contWords3
                };

                var val = vetTemp[x][1];
                var percent = getGreater(o1, o2, o3);
                percent = percent !== 'NaN' ? percent : 0;
                vetFinal.push([vetTemp[x][0],val,percent]);
            }

            vetFinal.sort((a,b)=>{return b[2] - a[2]});

            for (var x = 0; x < vetFinal.length; x++) {
                var letter = vetFinal[x][0];
                var val = vetFinal[x][1];
                var percent = vetFinal[x][2];
                if (letter.match(regexHas) || !letter.match(new RegExp(strDont, 'g'))) continue;
                str += letter + " --- " + val + " --- " + percent + "% --- " + contApTotal[letter] + " total<br>";
            }

            $('#letter').html(str);
            $('#words p').html(contWords);


        }

        function getGreater(o1, o2, o3) {

            o1.total = o1.total == 0 ? 1 : o1.total;
            o2.total = o2.total == 0 ? 1 : o2.total;
            o3.total = o3.total == 0 ? 1 : o3.total;

            var o1Num = o1.num / o1.total;
            var o2Num = o2.num / o2.total * (1 - o1Num);
            var o3Num = o3.num / o3.total * (1 - (o2Num + o1Num));

            var percent = Math.round((o1Num + o2Num + o3Num) * 10000) / 100;

            return percent;
        }
    </script>

</body>

</html>